package com.eactive.eai.batch.job.jobItem.bokng;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.adapter.socket.common.CommonLib;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.common.exception.ExceptionUtil;
import com.eactive.eai.common.secure.inisafe.IniSafeManager;

public class SEND_BOKNG_0001 extends DefaultTelegram implements TelegramService {

    private int SEND_LENGTH;            //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;       //실제 송신할 전문의 총길이
    private byte[] MSG = null;

    private final String TrCodeHandShake1        = "0001";   //세션키 교환 요구 (전문번호 : X0001)
    private final String TrCodeHandShake2        = "0002";   //세션키 교환 통보 (전문번호 : X0002)
    private final String TrCodeHandShake3        = "0003";   //세션키 교환 통보 응답 (전문번호 : X0003)
    private final String TrCodeHandShake4        = "0004";   //세션키 교환 확인 통보 (전문번호 : X0004)
    private final String TrCodeHandShake5        = "0005";   //세션키 교환 확인 통보 응답 (전문번호 : X0005)
    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_BOKNG_0001() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = prepareByteMsg();
            if (!result) return false;

            result = calculateSendLength();
            if (!result) return false;

            //필수 (전문전체길이 - 길이부길이)
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);
            
            //업무구분코드 - BOK
            compileField(1, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[1]);
            
            //국고망: 'BOK', 한은망: 'FTP'참가기관 코드
            //- 국고망 : 현행 기관코드(외부기관 지로코드)를 맨 앞에서 
            //3자리 기재 (마지막자리는 공백)
            //- 한은망 : 현행 기관코드(한국은행 부여 기관코드)를 기재
            compileField(2, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[2]);
            
            //전문 목록 상의 전문종별
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);
            
            //거래구분코드 (File Name) 
            compileField(4, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[4]);
            
            //전문 발생 (송신) 주체, 참가기관 발생: 'B', 한국은행 발생: 'C'
            compileField(5, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[5]);
            
            //전문처리결과, 정상: '000', 오류:  'A. 응답코드' 참조
            compileField(6, TelegramKeys.BOKGG_RES_CODE_SUCESS, this.al_FieldProps[6]);
            // 여기 까지 공통부
            
            //개별부의 전체길이
            // 개별데이터부 + 4
            compileField(7, Integer.toString(MSG.length + 4) , this.al_FieldProps[7]);
            
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return -1;
        }
    }

    public boolean doPreExecute() {
    	
        try {
            if (!super.doPreExecute()) return false;

            //BATCH작업구분코드 (processCode)에 따른 프로퍼티 정보 가져오기
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }

    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;

        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<7; i++) { 
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=7; i< al_Field.size()-1; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }
    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정현 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            	return MSG.length;
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return -1;
        }
    }

    /**
     * return value : 0 no left data to be sent
     *                -1 error
     *                >0 data copied to the data field
     *
     * 비정형 필드인 결번확인의 데이터를 얻어낸다.
     * 결번확인 데이터를 실어주고 결번확인 필드의 길이를 반환한다.
     */
    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            System.arraycopy( MSG, 0, data, 0, MSG.length);

            this.al_Field.set( idx, MSG);

            return MSG.length;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return -1;
        }
    }

    private boolean prepareByteMsg(){
        logger.debug("this.getFldTelegramType()-->" + this.getFldTelegramType());
        if ( this.getFldTelegramType().equals(TrCodeHandShake1)){
        	MSG = IniSafeManager.getInstance().initHandShakeClient(this.batchDoc);
        }else if ( this.getFldTelegramType().equals(TrCodeHandShake2)){
        	MSG = IniSafeManager.getInstance().initHandShake(this.batchDoc);
        }else if ( this.getFldTelegramType().equals(TrCodeHandShake3)){
        	MSG = IniSafeManager.getInstance().updateHandShakeClient(this.batchDoc);
        }else if ( this.getFldTelegramType().equals(TrCodeHandShake4)){
        	MSG = IniSafeManager.getInstance().updateHandShake(this.batchDoc);
        }else if ( this.getFldTelegramType().equals(TrCodeHandShake5)){
        	MSG = IniSafeManager.getInstance().finalHandShakeClient(this.batchDoc);
        }

        logger.debug("MSG-->" +  CommonLib.getDumpMessage(MSG));
        if ( MSG == null )
        	return false;

        return true;
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size() - 1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += this.getCalculatedLength(this.al_Field.size() - 1);
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 1 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
        return true;
    }
    

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(6);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
		return super.getFieldValueString(9);
    }

}
